;irplay.star:  ML core of playback program for learning remote control

;requires a string in stack level 1 generated by irsamp

		header	`x'

		code

		move.a	@d1, a		;put TOS obj pointer in a
		call	save_regs	;save RPL registers
		call	#01115		;disable interrupts
		call	#01bbd		;turn off display

		move.a	a, d1		;put TOS obj pointer in d1
		move.a	@d1, a		;get obj prolog
		move.p5	type_string, c	;get string prolog
		brne.a	c, a, bailout	;if not a string prolog abort
		add.a	5, d1		;move past string prolog
		move.a	@d1, c		;get string length field
		add.a	5, d1		;d1 now points to string data
		sub.a	5, c		;subtract 5 for length of string chars

		move.a	c, b
div3:		srb.a	c		;divide c by 4
		srb.a	c
		add.a	c, b		;add to b
		brnz.a	c, div3		;while c > 0
		srb.a	b		;divide b by 4, to get approx. c/3
		srb.a	b		;c.a is 0
		inc.a	c		;c.a is 1
		brle.a	b, c, bailout	;if b <= 1, no room for samples
		dec.a	b		;trust me, you need this

		move.5	#0011c, d0	;d0 points to IR LED output
playback:	move.3	@d1, c		;get a sample
		add	3, d1
		dec.x	c		;decrement repeat count
		move.xs	c, a		;copy IR state to a
playloop:	move.xs	c, @d0		;output current LED state
		dec.x	c		;decrement counter
		breq.xs	c, a, playloop	;timing only-branch never taken
		dec.a	b		;one less sample
		brcc	playback	;repeat until out of samples

		clr.a	c		;clear c.0
		move.1	c, @d0		;clear LED output

bailout:	call	#010e5		;allow interrupts
		call	#01b8f		;turn on display
		jump	rr_rplcont	;back to RPL

		endcode

