;irplay2.star:  ML core of playback program for learning remote control

;requires a string in stack level 1 generated by irsamp2

		header	`x'

		code

		move.a	@d1, a		;put TOS obj pointer in a
		call	save_regs	;save RPL registers
		call	#01115		;disable interrupts
		call	#01bbd		;turn off display

		move.a	a, d1		;put TOS obj pointer in d1
		move.a	@d1, a		;get obj prolog
		move.p5	type_string, c	;get string prolog
		brne.a	c, a, bailout	;if not a string prolog abort
		add.a	5, d1		;move past string prolog
		move.a	@d1, c		;get string length field
		add.a	5, d1		;d1 now points to string data
		sub.a	5, c		;subtract 5 for length of string chars

		move.a	c, b
		srb.a	b		;divide string length by two
		clr.a	c
		inc.a	c		;set c.a to 1
		brle.a	b, c, bailout	;if b <= 1, no room for samples
		dec.a	b		;trust me, you need this

		move.5	#0011b, d0	;d0 points to IR LED output - 1
		clr.a	a
		move	1, p
playback:	move.b	@d1, c		;get a sample
		add	2, d1
		dec.b	c		;predecrement c
		move.p	c, a		;copy IR state to a
playloop:	move.b	a, @d0		;output current LED state
		dec.x	c		;decrement counter
		breq.p	c, a, playloop	;while c.1 is unchanged, loop
		dec.a	b		;one less sample
		brcc	playback	;repeat until out of samples
		move	0, p

		clr.a	c		;clear c.0
		move.b	c, @d0		;clear LED output

bailout:	call	#010e5		;allow interrupts
		call	#01b8f		;turn on display
		jump	rr_rplcont	;back to RPL

		endcode

